<?php
namespace Mirasvit\Search\Model\ScoreRule\Indexer\ScoreRuleIndexer;

/**
 * Interceptor class for @see \Mirasvit\Search\Model\ScoreRule\Indexer\ScoreRuleIndexer
 */
class Interceptor extends \Mirasvit\Search\Model\ScoreRule\Indexer\ScoreRuleIndexer implements \Magento\Framework\Interception\InterceptorInterface
{
    use \Magento\Framework\Interception\Interceptor;

    public function __construct(\Magento\Framework\App\ResourceConnection $resource, \Mirasvit\Search\Repository\ScoreRuleRepository $scoreRuleRepository)
    {
        $this->___init();
        parent::__construct($resource, $scoreRuleRepository);
    }

    /**
     * {@inheritdoc}
     */
    public function executeFull()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'executeFull');
        return $pluginInfo ? $this->___callPlugins('executeFull', func_get_args(), $pluginInfo) : parent::executeFull();
    }

    /**
     * {@inheritdoc}
     */
    public function executeList(array $ids)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'executeList');
        return $pluginInfo ? $this->___callPlugins('executeList', func_get_args(), $pluginInfo) : parent::executeList($ids);
    }

    /**
     * {@inheritdoc}
     */
    public function executeRow($id)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'executeRow');
        return $pluginInfo ? $this->___callPlugins('executeRow', func_get_args(), $pluginInfo) : parent::executeRow($id);
    }
}
